#pragma once

class CJoint;

namespace nV
{

	class Joint
	{
		friend class JointMngr;

	protected:

        CJoint * pJoint;
		Joint(CJoint*);
		~Joint(void);
	};

	class HingeJoint : public Joint
	{
	protected:
		HingeJoint(CJoint*);
		~HingeJoint(void);
	public :
		void AddOneFrameTorque(float Torque);
		void SetMaxTorque(float MaxTorque);
		void SetRequiredVelocity(float vel);
		void ApproachRequiredVelocity();
		float GetVelocity();
		float GetAngle();
	};

	class CarWheelJoint : public Joint
	{
	protected:
		CarWheelJoint(CJoint*);
		~CarWheelJoint(void);
	public :
		void AddOneFrameTorque(float Torque);
		void SetMaxTorque(float MaxTorque);
		void SetRequiredVelocity(float vel);
		void SetSteeringAngle(float Angle);
		void ApproachRequiredVelocity();
		float GetVelocity();
		float GetAngle();
	};


	class DoubleHingeJoint : public Joint
	{
	protected:
		DoubleHingeJoint(CJoint*);
		~DoubleHingeJoint(void);
	public :
		void AddOneFrameTorque1(float Torque);
		void AddOneFrameTorque2(float Torque);

		void SetMaxTorque1(float MaxTorque);
		void SetRequiredVelocity1(float vel);

		void SetMaxTorque2(float MaxTorque);
		void SetRequiredVelocity2(float vel);
	};


	class LimitedBallJoint : public Joint
	{
	protected:
		LimitedBallJoint(CJoint*);
		~LimitedBallJoint(void);
	public :
		void SetMaxTorque(int axis, float MaxTorque);
		void SetMinLimit(int axis, float minAngle);
		void SetMaxLimit(int axis, float minAngle);
		void SetRequiredVelocity(int axis, float vel);
		float GetAngle(int axis);
	};
}