#pragma once
#include "BodyMngr.h"
#include "JointMngr.h"
#include "ShapeMngr.h"


class CPhEngine;
class Primitive;


namespace nV
{
	class Primitive;
	typedef bool (__cdecl * CollisionNotifyBackFnc)(void * pPrim1,void* pPrim2,float *ContactPoints,int NoOfContactPoints);

	class PhysicsWorld
	{
		CPhEngine * pEngine;
		//static CollisionNotifyBackFnc ColCallBack;
		//static bool CollideCallBack(::Primitive* p1,::Primitive* p2);
	public:

		BodyMngr BodyMngr;
		JointMngr JointMngr;
		ShapeMngr ShapeMngr;
		PhysicsWorld(void);
		~PhysicsWorld(void);

		void Reset();
		void RunStep(nvReal dtInSeconds);
		void RunStep(nvReal dtInSeconds,nvReal MaxDtInSeconds,int MaxNoOfTimeSegments);
		void RunUntil(unsigned long TimeInMilliseconds,nvReal MaxDtInSeconds = 0.01f,int MaxNoOfTimeSegments = 3);

		void SetCollisionNotify(CollisionNotifyBackFnc FnAddr);
		void SetGravity(nvReal xAcceleration,nvReal yAcceleration,nvReal zAcceleration);
		void SetNoOfSolvingIterations(int NoOfIterations);
		void SetObjectsAutoDeactivation(bool AutoDeactivateObjects);

		float GetTimeStep();
		int GetNoOfSolvingIterations();
	};
}