#pragma once
#include "types.h"

class CPrimitive;

namespace nV
{
	class Body;
	class Shape;

	class Primitive
	{
		friend class JointMngr;
		friend class Body;

		CPrimitive * pPrimitive;
		Body* pBody;
		Shape* pShape;

	protected:
		Primitive();
		Primitive(CPrimitive*, Body*, Shape*);
		~Primitive(void);
	public:

		void RotateAxisAngle(nvReal xAxis,nvReal yAxis,nvReal zAxis,nvReal angle);
	
		/* Setter & Getter */
		void SetElasticity(nvReal elasticity);
		nvReal GetElasticity();

		void SetFriction(nvReal friction);
		nvReal GetFriction();

		void SetData(void *pData);
		void* GetData();

		void SetLocalPosition(nvReal x,nvReal y,nvReal z);
		void GetLocalPosition(nvReal &x,nvReal &y,nvReal &z);
		void GetWorldPosition(nvReal &x,nvReal &y,nvReal &z);
		nvReal* GetWorldRotationMatrix();
		nvReal* GetLocalRotationMatrix();

		Body* GetBody();
		Shape*	GetShape();		//ezzay??
	};

}
