#pragma once

#include "./types.h"
class CShape;

namespace nV
{
	
	class Shape
	{
		friend class ShapeMngr;
		friend class Body;
		
	protected:

		CShape * pShape;

		Shape(CShape *);
		~Shape();

		
	public:

		enum eShapeType
		{
			PLANE=0,
			BOX=1,
			SPHERE=2,
			CYLINDER=3,
			CONVEX=4,
			TRIMESH=5
		};


	public:

		virtual nvReal GetBoundingRadius();
		virtual nvReal GetBoundingRadiusSqr();


		// get the type before u cast
		virtual Shape::eShapeType GetType();

	};
}