#ifndef _TWSITER_DOMINO_H_
#define _TWSITER_DOMINO_H_
/****************************************************
*	domino.h									    *
*	header file for the domino class                *
*   it is used to represent a mesh with 6 textures, *
*   each for one face                               *
****************************************************/

#include "3d/math/math.h"
#include "3d/3dtypes/texture.h"
#include "3d/meshes/indexmesh.h"


/****************************************************
*	struct sDomino declaration                    	*
****************************************************/

struct sDomino 
{
private:

    // 7 textures
    sTexture m_Textures[7];

    // create one face of the domino piece, (make its vertex buffer)
    void Createface(Matrix4& matrix);

    // the meshes for the faces are in here
    vector<sIndexedMesh*> m_Faces;


public:


    // constructor, make sure everything in zero
    sDomino();

    // destroy the domino mesh
    virtual ~sDomino();

    // create the textures and the vertex buffers
    void Create(float pieceWidth);

    // render the domino piece
    void Render(unsigned int up,unsigned int down);
   
};
/*------------end of sDomino declaration-----------*/
#endif //_TWSITER_DOMINO_H_