//#include "../system/engine.h"
//#include "../3d/3dtypes/3dtypes.h"
//#include "../audio/audio.h"
//
//#include "boxmesh.h"
//
//// this is for ODE
//#include "../physics/physics.h"
//
//// and this is for TPE
//#include "phengine.h"
//
//// header implemented here
//#include "pivot.h"
//#include "tpe.h"
//
//
//
//
//// the ground box dimensions
//Vector3 g_PivotGround(100.0f,2.0f,100.0f);
//Vector3 g_LeverDimensions(80.0f,1.0f,10.0f);
//Vector3 g_LeverPosition(0.0f,6.0f,0.0f);
//Vector3 g_LeverCG(0.0f,6.0f,0.0f);
//Vector3 g_HingePosition(27.0f,5.0f,0.0f);
//float   g_LeverDensity=0.01f;
//float   g_PivotBallsRadius=1.0f;
//float   g_PivotBallsDensity=0.1f;
//int     g_NumPivotBalls=40;
//float   g_LeverDemoGravity=-9.8f;
//
//cMusic * g_pPivotMusic=NULL;
//sTexture* g_pPivotGroundTexture=NULL;
//cCamera g_PivotCamera;
//
//
//sBoxMesh g_PivotGroundMesh;
//void SetPivotCamera(cCamera& camera)
//{
//    g_PivotCamera=camera;
//}
//
//
//struct sLeverBox
//{
//    Vector3 Position;
//    Vector3 Dimensions;
//};
//
//sLeverBox g_LevelBoxes[4];
//
//
//
//// setup the boxes sizes and initial positions
//void SetupLeverBoxes()
//{
//    g_LevelBoxes[0].Dimensions.Assign(g_LeverDimensions.x,g_LeverDimensions.y,g_LeverDimensions.z);
//    g_LevelBoxes[1].Dimensions.Assign(g_LeverDimensions.y,g_LeverDimensions.z,g_LeverDimensions.z);
//    g_LevelBoxes[2].Dimensions.Assign(g_LeverDimensions.z,g_LeverDimensions.z,g_LeverDimensions.y);
//    g_LevelBoxes[3].Dimensions.Assign(g_LeverDimensions.z,g_LeverDimensions.z,g_LeverDimensions.y);
//
//    g_LevelBoxes[0].Position.Assign(g_LeverPosition.x,g_LeverPosition.y,g_LeverPosition.z);
//    g_LevelBoxes[1].Position.Assign(g_LeverPosition.x+(g_LeverDimensions.x/2.0f-g_LeverDimensions.z),
//        g_LeverPosition.y+g_LeverDimensions.z/2.0f+g_LeverDimensions.y/2.0f,
//        g_LeverPosition.z);
//
//    g_LevelBoxes[2].Position.Assign(g_LeverPosition.x+(g_LeverDimensions.x/2.0f-g_LeverDimensions.z/2.0f),
//        g_LeverPosition.y+g_LeverDimensions.z/2.0f+g_LeverDimensions.y/2.0f,
//        g_LeverPosition.z+g_LeverDimensions.z/2.0f+g_LeverDimensions.y/2.0f);
//
//    g_LevelBoxes[3].Position.Assign(g_LeverPosition.x+(g_LeverDimensions.x/2.0f-g_LeverDimensions.z/2.0f),
//        g_LeverPosition.y+g_LeverDimensions.z/2.0f+g_LeverDimensions.y/2.0f,
//        g_LeverPosition.z-g_LeverDimensions.z/2.0f-g_LeverDimensions.y/2.0f);
//
//
//    // compute the correct CG..
//    Vector3 sum(0,0,0);
//
//    for(int i=0;i<4;i++)
//    {
//        float currentMass=g_LevelBoxes[i].Dimensions.x*g_LevelBoxes[i].Dimensions.y*g_LevelBoxes[i].Dimensions.z*g_LeverDensity;
//        sum+=currentMass*g_LevelBoxes[3].Position;
//    }
//
//    g_LeverCG=sum/4.0f;
//
//
//
//
//    // create the stupid mesh
//    g_PivotGroundMesh.Create(g_PivotGround.x,g_PivotGround.y,g_PivotGround.z,5,5,5);
//
//}
//
//
//// first... ODE
//cStaticBody*        pGroundBody  =   NULL;
//cGeomBox*           pGroundGeom  =   NULL;
//
////cRigidBody*         pLeverBody  =   NULL;
//cHinge*             pLeverHinge =   NULL;
//vector<cGeom*>      LeverGeoms;
//vector<cRigidBody*> LeverBodies;
//vector<cJoint*>     LeverJoints;
//
////  balls
//vector<cRigidBody*>      LeverBallBodies;
//vector<cGeomSphere*>     LeverBallGeoms;
//
//
//// create the pivot scene here
//void CreatePivotODE()
//{
//    // set the world gravity
//    Physics()->SetWorldGravity(0,g_LeverDemoGravity,0);
//    Physics()->m_Restitution=0.0f;
//
//    // set up the levr boxes
//    SetupLeverBoxes();
//
//    // create the ground
//    pGroundGeom=new cGeomBox(1,g_PivotGround.x,g_PivotGround.y,g_PivotGround.z);
//    pGroundGeom->SetPosition(0,0,0);
//    pGroundBody=new cStaticBody();
//    pGroundBody->AddGeometry(*pGroundGeom);
//
//
//    for(int i=0;i<4;i++)
//    {
//        Vector3& currPos=g_LevelBoxes[i].Position;
//        Vector3& currDim=g_LevelBoxes[i].Dimensions;
//        cGeomBox* pLeverGeom1=new cGeomBox(g_LeverDensity,currDim.x,currDim.y,currDim.z);
//
//
//        LeverGeoms.push_back(pLeverGeom1);
//
//        cRigidBody* pLeverBody1=new cRigidBody();
//        pLeverBody1->AddGeometry(*pLeverGeom1);
//        pLeverBody1->LockGeometries();
//        pLeverBody1->SetPosition(currPos.x,currPos.y,currPos.z);
//        LeverBodies.push_back(pLeverBody1);
//
//
//        if(i>0)
//        {
//            // fix them all with the first
//            cFixedJoint* pFixedJoint1=new cFixedJoint();
//            pFixedJoint1->AttachBodies(pLeverBody1,LeverBodies.front());
//            LeverJoints.push_back(pFixedJoint1);
//        }
//    }
//
//    // create the hinge
//    pLeverHinge =   new cHinge();
//    pLeverHinge->AttachBodies(NULL,LeverBodies.front());
//    pLeverHinge->SetAnchor(g_HingePosition.x,g_HingePosition.y,g_HingePosition.z);
//    pLeverHinge->SetAxis(0,0,1);
//
//
//    // create the balls
//    for(int i=0;i<g_NumPivotBalls;i++)
//    {
//        cRigidBody  *pBallBody  =  new cRigidBody();
//        cGeomSphere *pBallGeom  =  new cGeomSphere(g_PivotBallsDensity,g_PivotBallsRadius);
//        pBallBody->AddGeometry(*pBallGeom);
//        pBallBody->SetPosition(g_LeverDimensions.x/2.0f-g_LeverDimensions.z/4.0f,g_LeverPosition.y+10.0f*i+30.0f,0);
//
//        LeverBallBodies.push_back(pBallBody);
//        LeverBallGeoms.push_back(pBallGeom);
//    }
//}
//
//// render the pivot scene here
//void RenderPivotODE(float dt)
//{
//    Physics()->Update(dt);
//    pGroundBody->RenderGeometries();
//
//
//    pLeverHinge->Render();
//
//
//    Material m;
//    m=Material::AQUA_GLAZE;
//
//    m.Activate();
//    for(unsigned int i=0;i<LeverBodies.size();i++)
//    {
//        LeverBodies[i]->RenderGeometries();
//    }
//    m.Deactivate();
//    m=Material::CHERRY_RED_METAL;
//    m.Activate();
//    for(unsigned int i=0;i<LeverBallBodies.size();i++)
//    {
//        LeverBallBodies[i]->RenderGeometries();
//    }
//    m.Deactivate();
//}
//
//// push the pivot here
//void PushPivotODE()
//{
//
//}
//
//
//// destroy the pivot here
//void DestroyPivotODE()
//{
//    SAFE_DELETE(pGroundBody);
//    SAFE_DELETE(pGroundGeom);
////    SAFE_DELETE(pLeverGeom);
//
//    DestroyVector(LeverGeoms);
//    DestroyVector(LeverBodies);
//    DestroyVector(LeverJoints);
//    DestroyVector(LeverBallBodies);
//    DestroyVector(LeverBallGeoms);
//
//    SAFE_DELETE(pLeverHinge);
//
//}
//
//
//
//
//
//
//
//
//
//
//
//CVBody* pTPEGroundBody=NULL;
//vector<CVBody*> g_TPELeverBodies;
//vector<CVBody*> g_TPELeverBalls;
//
//
//
//
//// create the pivot scene here
//void CreatePivotTPE()
//{
//    // the physics engine itself
//    pTPEEngine=new CPhEngine();
//
//    pTPEEngine->SetGravity(0.0f,g_LeverDemoGravity,0.0f);
//    // create the ground
//    pTPEGroundBody=pTPEEngine->VBodies.Create();
//    pTPEGroundBody->CreateBox(-1,g_PivotGround.x,g_PivotGround.y,g_PivotGround.z);
//    pTPEGroundBody->SetPosition(0,0,0);
//
//    // create the 4 bodies of the lever and link them using fixed joints
//    SetupLeverBoxes();
//
//    CVBody* pNewLeverBody=pTPEEngine->VBodies.Create();
//    //pNewLeverBody->SetPosition(g_LeverPosition.x,g_LeverPosition.y,g_LeverPosition.z);
//
//    // now create the bodies and link them all
//    for(int i=0;i<4;i++)
//    {
//        Vector3& currPos=g_LevelBoxes[i].Position;//-g_LevelBoxes[0].Position;
//        Vector3& currDim=g_LevelBoxes[i].Dimensions;
//        float mass=currDim.x*currDim.y*currDim.z*g_LeverDensity;
//        CPrimitive* pGeom=pNewLeverBody->CreateBox(mass,currDim.x,currDim.y,currDim.z);
//        pGeom->SetLocalPosition(currPos.x-g_HingePosition.x+1.0f,currPos.y-g_HingePosition.y,currPos.z-g_HingePosition.z);
//        pGeom->SetElasticity(0.1f);
//        pGeom->SetFriction(0.3f);
//    }
//    
//    pNewLeverBody->SetPosition(g_HingePosition.x-1.0f,g_HingePosition.y,g_HingePosition.z);
//    g_TPELeverBodies.push_back(pNewLeverBody);
//    
//    // create the hinge
//	pTPEEngine->Joints.CreateHingeJoint(pTPEGroundBody,g_TPELeverBodies.front(),g_HingePosition.x,g_HingePosition.y,g_HingePosition.z,0,0,1);
//
//    // create the balls
//    for(int i=0;i<g_NumPivotBalls;i++)
//    {
//        float mass=4.0f/3.0f*PI*g_PivotBallsRadius*g_PivotBallsRadius*g_PivotBallsRadius;
//        mass=mass*g_PivotBallsDensity;
//        CVBody* pNewBallBody=pTPEEngine->VBodies.Create();
//        CPSphere *pShere=pNewBallBody->CreateSphere(mass,g_PivotBallsRadius);
//        pNewBallBody->SetPosition(g_LeverDimensions.x/2.0f-g_LeverDimensions.z/4.0f,g_LeverPosition.y+10.0f*i+30.0f,0);
//        pShere->SetElasticity(0.9f);
//        pShere->SetFriction(0.3f);
//
//        g_TPELeverBalls.push_back(pNewBallBody);
//    }
//
//}
//
//// render the pivot scene here
//void RenderPivotTPE(float dt)
//{
//    Matrix4 currMatrix;
//
//    pTPEEngine->RunStep(dt);
//    
//    ComputeTPEBodyTransform(pTPEGroundBody,currMatrix);
//
//    g_pPivotGroundTexture->Activate();
//
//    
//    Graphics()->PushMatrix();
//    Graphics()->MultMatrix(currMatrix.d);
//    g_PivotGroundMesh.Render();
//    Graphics()->PopMatrix();
//    g_pPivotGroundTexture->Deactivate();
//    
//
//
//    Material m;
//
//    m=Material::AQUA_GLAZE;
//    m.Activate();
//
//    ComputeTPEBodyTransform(g_TPELeverBodies[0],currMatrix);
//
//
//    Graphics()->PushMatrix();
//    Graphics()->MultMatrix(currMatrix.d);
//
//        CVBody* pBody=g_TPELeverBodies[0];
//    
//    //g_TPELeverBodies[0]->
//    for(unsigned int i=0;i<pBody->Primitives.size();i++)
//    {
//        CPBox* pBox=(CPBox*)pBody->Primitives[i];
//        Vector3& currDim=g_LevelBoxes[i].Dimensions;
//        float x,y,z;
//        pBox->GetLocalPosition(x,y,z);
//        Graphics()->PushMatrix();
//        Graphics()->Translate(x,y,z);
//        Graphics()->RenderBox(currDim.x,currDim.y,currDim.z);
//        Graphics()->PopMatrix();
//    }
//
//    Graphics()->PopMatrix();
//
//
//    m.Deactivate();
//    m=Material::CHERRY_RED_METAL;
//    m.Activate();
//    for(unsigned int i=0;i<g_TPELeverBalls.size();i++)
//    {
//        ComputeTPEBodyTransform(g_TPELeverBalls[i],currMatrix);
//        Graphics()->PushMatrix();
//        Graphics()->MultMatrix(currMatrix.d);
//        Graphics()->RenderSphere(g_PivotBallsRadius);
//        Graphics()->PopMatrix();
//    }
//    m.Deactivate();
//}
//
//
//// push the pivot here
//void PushPivotTPE()
//{
//
//}
//
//
//// destroy the pivot here
//void DestroyPivotTPE()
//{
//    g_TPELeverBodies.clear();
//    g_TPELeverBalls.clear();
//    SAFE_DELETE(pTPEEngine);
//}
//
//void CreatePivot(int APIID)
//{
//    g_pPivotMusic=new cMusic("data/autumn.mid");
//    g_pPivotMusic->Play();
//    g_pPivotGroundTexture=new sTexture("data/wallpaper.jpg");
//    if(APIID==1)
//        CreatePivotTPE();
//    //else
//      //  CreatePivotODE();
//}
//
//
//void RenderPivot(float dt,int APIID,bool updateOnly)
//{
//    if(APIID==1)
//        RenderPivotTPE(dt);
//    //else
//      //  RenderPivotODE(dt);
//
//}
//void PushPivot(int APIID)
//{
//    if(APIID==1)
//        PushPivotTPE();
//    //else
//      //  PushPivotODE();
//}
//void DestroyPivot(int APIID)
//{
//    if(APIID==1)
//        DestroyPivotTPE();
//    //else
//      //  DestroyPivotODE();
//
//
//    g_pPivotMusic->Stop();
//    SAFE_DELETE(g_pPivotMusic);
//    SAFE_DELETE(g_pPivotGroundTexture);
//}
//
//
//void DisplayPivotHelp()
//{
//
//}
