#ifndef _TWISTER_VEHICULE_H_
#define _TWISTER_VEHICULE_H_

#include "nvphysics.h"
#include "tpe.h"
#include "3d/meshes/indexmesh.h"
#include "3d/math/math.h"
#include "3d/graphics/graphicssubsystem.h"

class cVehicule
{

public:

    nV::Body* m_pChasisBody;
    vector<nV::Body*> m_Wheels;
    //vector<CVBody*> m_pRearWheels;


    nV::CarWheelJoint* m_pFrontLeftJoint;
    nV::CarWheelJoint* m_pFrontRightJoint;
    nV::CarWheelJoint* m_pRearLeftJoint;
    nV::CarWheelJoint* m_pRearRightJoint;


    sIndexedMesh* m_pChasisMesh;
    sMesh* m_pWheelMesh;


    Vector3 m_ChasisDims;
    float m_WheelsRadius;

    Vector3 m_FrontLeftPos;
    Vector3 m_FrontRightPos;
    Vector3 m_RearLeftPos;
    Vector3 m_RearRightPos;
    Vector3 m_BodyPos;

    float m_WheelsFriction;
    float   m_BodyMass;
    float m_WheelMass;
    float m_MaxAngle;

    cVehicule();

    virtual ~cVehicule()
    {
        SAFE_DELETE(m_pChasisMesh);
        SAFE_DELETE(m_pWheelMesh);
    }

    void Create(PhysicsWorld* pEngine);


    void Handle();



};

#endif //_TWISTER_VEHICULE_H_