#ifndef _ArcBall_h
#define _ArcBall_h

#include "../math/matrix4.h"
#include "../math/matrix3.h"



class cArcBall
{
    protected:

        Vector3     StVec;       
        Vector3     EnVec;
        float       AdjustWidth;
        float       AdjustHeight;
        
        Matrix3	    PrevRotation;
        Matrix3	    CurrentRotation;
        
        bool		isDragging;


        inline  void MapToSphere(const Vector2* NewPt, Vector3* NewVec) const;


        //Mouse drag, calculate rotation
        void    Drag(const Vector2* NewPt, Vector4* NewRot);


    public:

        //Create/Destroy
        cArcBall(float NewWidth, float NewHeight);

        ~cArcBall() {};


        void Update(float mouseX,float mouseY,bool buttonDown);
        

        //Set new bounds
        inline  void  SetBounds(float NewWidth, float NewHeight)
        {
            AdjustWidth  = 1.0f / ((NewWidth  - 1.0f) * 0.5f);
            AdjustHeight = 1.0f / ((NewHeight - 1.0f) * 0.5f);
        }

        // this is the matrix which can be used outside
        Matrix4	Transform;
};
#endif