#ifndef _POINT_LIGHT_H_
#define _POINT_LIGHT_H_
/********************************************************
*	pointlight.h										*
*	header file for the point light						*
********************************************************/

#include "light.h"	//	base class


/********************************************************
*	sPointLight declaration								*
********************************************************/
struct PointLight : public Light
{
	float		m_Range;				//	the range of the light, will be always maximal
	float		m_Attenuation0;			//	constant attenuation factor
	float		m_Attenuation1;			//	Linear attenuation factor
	float		m_Attenuation2;			//	quadratic attenuation factor

	//	construct with all required settings
	PointLight		(		
					const Vector3& loc,
					const Color3&	diff	=	Color3::White,
					const Color3&	spec	=	Color3::Black,
					const Color3&	amb		=	Color3::Black
					);

	//	activates the point source light
	void Activate();
};
/*------------end of sPointLight declaration-----------*/

#endif // _POINT_LIGHT_H_