#ifndef _SPOT_LIGHT_H_
#define _SPOT_LIGHT_H_

/********************************************************
*	spotlight.h											*
*	header file for the point light						*
********************************************************/
#include "light.h"
/********************************************************
*	sSpotLight declaration								*
********************************************************/
struct SpotLight : public Light
{
	float		m_Range;				//	range of the spotlight, will be maximal
	float		m_Attenuation0;			//	constant attenuation factor
	float		m_Attenuation1;			//	Linear attenuation factor
	float		m_Attenuation2;			//	quadratic attenuation factor
	float		m_Theta;				//	angle of the spot light


	//	construct with all settings
	SpotLight	(
				const Vector3& loc,
				const Vector3& dir,
				float theta,
				const Color3&	diff	=	Color3::White,
				const Color3&	spec	=	Color3::Black,
				const Color3&	amb		=	Color3::Black
				);

	//	activate the spot light
	void Activate();
};
/*------------end of sSpotLight declaration------------*/

#endif // _SPOT_LIGHT_H_