#ifndef _TWISTER_TEXTURE_H_
#define _TWISTER_TEXTURE_H_
/********************************************************
*	texture.h											*
*	By Shady El Mously									*
*	part of the Twister	3d engine						*
*	this is the delcaration file for the etxture class	*
********************************************************/

#include "../hybrid/meshcompiler.h"

/********************************************************
*	struct sTexture										*
*	used to represent m_Textures , which may be loaded	*
*	from different iMage files format					*
*	activated/deactivated								*
********************************************************/
struct sTexture
{
private :

    // internal texture class... not for use outside
    sInternalTexture* m_pInternalTexture;

public:


    //	constructor
    sTexture()
    {
        m_pInternalTexture  =   0;
    }

    //	constructor using a file
    sTexture(const char * filename)
    {		Create(filename);	}


    //	destructor delete the texture
    ~sTexture()
    {
        SAFE_DELETE(m_pInternalTexture);
    }

    //	Create from a file
    void Create(const char* strFilename)
    {
        m_pInternalTexture=MeshCompiler()->CreateInternaltexture(strFilename);
    }
    //	Create from data
    void Create(const char* pData,short sizeX,short sizeY)
    {
        m_pInternalTexture=MeshCompiler()->CreateInternaltexture(pData,sizeX,sizeY);
    }

    // activate the texture on stage 0
    void Activate()
    {
        m_pInternalTexture->Bind();
    }

    // DeActivate the texture on stage 0
    void Deactivate()
    {
        m_pInternalTexture->UnBind();
    }

    // activate the texture on stage any stage
    void Activate(int stage)
    {
        m_pInternalTexture->Bind(stage);
    }

    // DeActivate the texture on stage 0
    void Deactivate(int stage)
    {
        m_pInternalTexture->UnBind(stage);
    }

};
/*-------------end of sTexture declaration--------------*/

#endif // _TWISTER_TEXTURE_H_