#ifndef _BSP_CAMERA_H
#define _BSP_CAMERA_H

/********************************************************
*	bspcamera.h											*
*	header declaration for the camera class used in the	*
*	bsp file Renderer									*
********************************************************/

#include "../3dtypes/camera.h"
#include "bspfile.h"

#define STEP_UP Vector3(0,10.0f,0)
#define PLAYER_BOUNDING_SPHERE_RADIUS 20.0f
/********************************************************
*	class cBSPCamera declaration						*
********************************************************/
class cBSPCamera : public cCamera	
{
private:

    //	a pointer to the used bsp file
    cBSPFile*				m_pMap;

    // this will try to slide the camera...
    bool TrySlide(Vector3 vFrom,Vector3 vDeltha);

    // this is helpful in climbing stairs..
    bool TryStepUpAndSlide(Vector3 deltha);

public:

    // the gravity
    float m_Gravity;

    //	always and must be constructed using an already existing bsp file
    cBSPCamera()
    {
        m_pMap	=	NULL;
        m_Gravity	=	0.0f;
    }

    //	this will set the map to be used with the camera..
    //	the player position should be in a safe standing position
    void SetMap(cBSPFile& Map);

    //	this will update the camera motion using bird's eye method
    void Handle(float Elapsed);

};
/*-------------end of cBSPCamera declaration-----------*/
#endif // _BSP_CAMERA_H