#ifndef _BSPENTITIES_H_
#define _BSPENTITIES_H_
/********************************************************
*	bspentities.h										*
*	By Shady El Mously									*
*	this is a header file for all bsp entities			*
*	entities are map objects such as doors, player		*
*	positions, health, armor and weapons				*
********************************************************/
#include <vector>
#include "../../util/string.h"
#include "../math/math.h"
using std::vector;

/********************************************************
*	struct sEntity										*
*	represent an entity									*
********************************************************/
struct sEntity 
{
    // two arrays of names and values.. like a map from string to string
    vector<string>	names;
    vector<string>	values;

    //	all enitities have a class Name
    string	Classname;

    //	Add a key/value pair
    void Add(string name,string Value);

    //	get the value from the name
    char* GetValueOf(const char * Valuename);

    //	this will ty to fill a 3d vector..return false on failure
    bool	Get3DValue(Vector3& VectorToFill,char* Valuename);

    //	many entities have origin and model.. so they have special functions to get them

    //	get the origin of an entity
    bool	GetOrigin(Vector3& origin)
    {	 return Get3DValue(origin,"origin");	}
    //	get an index to a model
    bool	GetModel(int& Index);
};
/*-----------------------------------------------------*/
#endif // ENTITIES
