#ifndef _TWISTER_BSPMODEL_H_
#define _TWISTER_BSPMODEL_H_
/****************************************************************
* mapobject.h												    *
* By Shady El Mously											*
* Part of the Twister 3d engine									*
* declaration file for the cMapObject class		    			*
****************************************************************/

#include "../../graphics/graphicssubsystem.h"
#include "../../math/math.h"
#include "../faces/faces.h"

/********************************************************
*	class cMapObject declaration						*
********************************************************/
class cBSPModel
{
public:

    //	dimensions of the bounding box
    Vector3		min	;	
    Vector3		max	;	

    //	center of the object 
    Vector3		center;

    //	faces of the model used to Render it 
    vector<sBSPFace*>	faces;

    //	simple constructor
    cBSPModel()
    {
        min.Assign(0,0,0);
        max.Assign(0,0,0);
        center.Assign(0,0,0);
    }

    //	virtual destructir
    virtual ~cBSPModel()
    {}

    //	Render the map object
    virtual void Render();
};
/*----------end of class cBSPModel declaration---------*/
#endif // _TWISTER_BSPMODEL_H_
