#ifndef _TWISTER_MAPDOOR_H_
#define _TWISTER_MAPDOOR_H_
/****************************************************************
* mapdoor.h														*
* By Shady El Mously											*
* Part of the Twister 3d engine									*
* declaration file for the cMapDoor class		    			*
****************************************************************/

#include "bspmodel.h"
//#include "../../graphics/glext.h"				//	OpenGL Extensions

/****************************************************************
*	class cMapDoor												*
*	represents a door in the map, this is a template for		*
*	sliding and rotating doors									*
****************************************************************/
class cMapDoor : public cBSPModel
{
protected:

    float	timer		;

public:

    int		state		;	//	state of the door (one of 5 states)
    int		leafIndex	;	//	index for the leaf that contains the door
    float	timerMax	;	//	the time until the door will automatically close

    //	constructor
    cMapDoor()
    {
        state		=	0	;
        timer		=	0	;
        timerMax	=	100	;
        leafIndex	=	-1	;
    }

    //	returns true the door can be activated fromthe sent location
    bool	CanBeOpened(const Vector3& Pos);

    //	update the rotating door (change its state)
    virtual void Update(float Elapsed)=0;


    //	open the door from a location
    virtual void OpenFrom(const Vector3& position)=0;
};
/*-----------------end of cMapDoor declaration-----------------*/
#endif // _TWISTER_MAPDOOR_H_
