#ifndef _ROTATING_DOOR_H
#define _ROTATING_DOOR_H

/********************************************************
*	rotatingdoor.h										*
*	By Shady El Mously									*
*	header declaration for rotating door class			*
********************************************************/
#include "mapdoor.h"			//	base class


//	types of rotating door
#define ROTDOOR_OPENFREE			0
#define ROTDOOR_OPENIN				1
#define ROTDOOR_OPENOUT				2

//	states of the rotating door
#define ROTDOOR_STATE_CLOSED		0
#define ROTDOOR_STATE_OPENING_IN	1
#define ROTDOOR_STATE_OPENING_OUT	2
#define ROTDOOR_STATE_CLOSING_IN	3
#define ROTDOOR_STATE_CLOSING_OUT	4
#define ROTDOOR_STATE_OPENED_IN		5
#define ROTDOOR_STATE_OPENED_OUT	6

/********************************************************
*	class cRotDoor										*
*	represetns a rotating door in the level				*
********************************************************/
class cRotDoor : public cMapDoor
{
private:

    float	angle		;	//	angle of the door

public:

    Vector3	axisPosition	;	//	location of the axe of rotation of the door
    int		type		;	//	the door type (open in/out or free)	default is free


    //	constructor
    cRotDoor(const Vector3& AxeLoc,int Type)
    {
        axisPosition	=	AxeLoc	;
        angle		=	0		;
        type		=	Type	;
    }

    //	Render the rotating door
    void Render();

    //	open the door from a location
    void OpenFrom(const Vector3& Loc);

    //	update the rotating door (change its state)
    void Update(float Elapsed);
};
/*---------------end of cRotDoot declaration-----------*/


#endif // _ROTATING_DOOR_H