#ifndef _SLIDING_DOOR_H_
#define _SLIDING_DOOR_H_

/********************************************************
*	slidingdoor.h										*
*	By Shady El Mously									*
*	header declaration file dor the sliding door class	*
********************************************************/

#include "mapdoor.h"			//	base class

//	States of the sliding door (4 states until now)
#define SLIDEDOOR_STATE_CLOSED	0
#define SLIDEDOOR_STATE_OPENED	1
#define SLIDEDOOR_STATE_OPENING	2
#define SLIDEDOOR_STATE_CLOSING	3


/********************************************************
*	class cSlidingDoor declaration						*
********************************************************/
class cSlidingDoor : public cMapDoor
{
private:

    Vector3	slidingDirection	;	//	unit vector (Direction of sliding)
    float	slidingLength		;	//	length of sliding (0 is closed)

public:

    //	always construct with and angle and minimum and maximum
    cSlidingDoor(float Angle,Vector3& Min,Vector3& Max);

    void Update(float Elapsed);
    void Render();

    //	open the door from a location
    void OpenFrom(const Vector3& Loc);
};
/*-----------end of cSlidingDoor declaration-----------*/


#endif // _SLIDING_DOOR_H_
