#ifndef _FRUSTUM_H
#define _FRUSTUM_H

/********************************************************
*	frustum.h											*
*	part of the twsiter 3d engine						*
*	this is the header file for the frustum class		*
********************************************************/


/********************************************************
*	Frustum module										*
*	this module is used to detect the visiblity of		*
*	objects	it used the internal OGL transformation		*
*	matrices to compute the	frustum planes, and has		*
*	functions to test the existence of	objects inside	*
*	this frustum this is a great optimization way for	*
*	the engine, because now	only visible objects can	*
*	be drawn in the scene, and no matter how many		*
*	objects are in the Render loop, only the visible	*
*	ones will be drawn									*
********************************************************/
#include "..\math\plane.h"

// This holds the A B C and D values for each side of our frustum.
//	there are 6 planes and each has its plane data (normal vector and Distance to origin)
//	i can treat this data as separate planes or as a big array of floats
struct sFrustumData
{
    union
    {
        struct
        {
            Plane	Right	;	//	right	plane of the frustum
            Plane	Left	;	//	left	plane of the frustum
            Plane	Bottom	;	//	bottom	plane of the frustum
            Plane	Top		;	//	top		plane of the frustum
            Plane	Back	;	//	back	plane of the frustum
            Plane	Front	;	//	front	plane of the frustum
        };
        float	Data[6][4];
    };
};
/*-----------end of Frustum declaration---------------*/
#endif // _FRUSTUM_H