#ifndef _TWSITER_IMAGE_H_
#define _TWSITER_IMAGE_H_

/********************************************************
*	iMage.h												*	
*	By Shady El Mously									*
*	part of the twsiter 3d engine						*
********************************************************/
/********************************************************
*	struct sImage										*
*	holds the byte data of an iMage						*
*	this types is universal for any type of iMage files	*
********************************************************/
struct sImage
{
	short			sizeX		;	//	Width of iMage
	short			sizeY		;	//	Height of iMage
	short			numChannels	;	// The channels in the iMage (3 = RGB : 4 = RGBA)
	unsigned char*	m_pData		;	//	actual data of the iMage

	//	Creates a new instance of sImage
	sImage()
	{
		sizeX		=	0;
		sizeY		=	0;
		numChannels	=	3;
		m_pData		=	0;
	}

	//	deallocate the iMage data bytes
	void free()
	{		if(m_pData)			delete [] m_pData;	}

	//	destructor
	~sImage()
	{		free();	}

	//	an extra function..which will convert the data from 3 to 4 channels
	//  Adding an extra alpha channel, the contents may be anything
	//  for now..just make the black Dots Zeros...else ones
	void MakeAlpha();

};
/*-----------end of struct sImage declaration-----------*/



//	Load/Save IMage Data
void	SaveImage(sImage& image,char* FileName);
sImage*	LoadImage(const char * fileName);


#endif // _TWSITER_IMAGE_H_