#ifndef _MATH_GLOBALS_H_
#define _MATH_GLOBALS_H_

/********************************************************
*	globals.h											*
*	By Shady El Mously									*
*	this is header file for the math globalsused in the	*
*	twister 3d engine									*
********************************************************/


#define EPSILON 0.001f
#ifndef PI
#define PI 3.1415926f
#endif
#define SIGN_BIT 0x80000000
#define INV_SIGN_BIT 0x7FFFFFFF

// a cute macro for detecting signs
#define SIGN(x)  ((x)>0?1:-1)

// some fast important functions
// perform absolute value by AND'ing out the sign bit
inline float fastabs( const float &in )
{
	int* temp = (int*)&in;
	int out = *temp & INV_SIGN_BIT;
	return *((float*)&out);
}


#endif // _MATH_GLOBALS_H_
