#ifndef _POLYGON_H_
#define _POLYGON_H_
/********************************************************
*	polygon.h											*
*	header for the template polygon data type			*
********************************************************/

/********************************************************
*	spolygon data type declaration						*
********************************************************/
template <class type>
struct sPolygon 
{
	int numelem; // number of elements in the polygon
	int maxelem; // maximaum elemts the polygon can have

	type *plist;

	sPolygon()
	{
		numelem = 0;
		maxelem = 0;
		plist = NULL;
	}

	sPolygon( int maxSize )
	{
		maxelem = maxSize;
		plist = new type[maxSize];
	}

	sPolygon(const sPolygon &in)
	{
		clonedata( in );
	}

	~sPolygon()
	{
		destroydata();
	}

	void clonedata( const sPolygon &in )
	{
		if( !in.plist ) 
			return;

		plist = new type[in.maxelem];
		maxelem = in.maxelem;
		numelem = in.numelem;
		for( int i=0; i<in.numelem; i++ )
		{
			plist[i] = in.plist[i];
		}
	}

	void destroydata( )
	{
		if( plist )
		{
			delete[] plist;
		}
		plist = NULL;
	}

	sPolygon& operator=(const sPolygon<type> &in )
	{
		if( &in != this )
		{
			destroydata();
			clonedata( in );
		}
		return *this;
	}
};
/*---------------end of sPolygon declaration------------*/
#endif	//	_POLYGON_H_