#ifndef _TWISTER_MD3_MESH_H_
#define _TWISTER_MD3_MESH_H_

#include "md3types.h"
#include "../meshes/indexmesh.h"
#include "../3dtypes/texture.h"


// This holds all the information for our model/scene. 
// You should eventually turn into a robust class that 
// has loading/drawing/querying functions like:
// LoadModel(...); DrawObject(...); DrawModel(...); DestroyModel(...);
struct sMD3Mesh : public sIndexedMesh
{
    int         m_NumVertsPerFrame;			// The number of verts in the model
    int         materialID;			// The texture ID to use, which is the index into our texture array
    bool        bHasTexture;			// This is TRUE if there is a texture map for this object
    char        strName[255];			// The name of the object
    Vector3*    pVerts;			// The object's vertices
    // Vector3  *pNormals;		// The object's normals
    sTexture*   pTexture;

    sMD3Mesh()
    {
        pTexture=NULL;
        pVerts=NULL;
        materialID=0;
        //   pNormals=NULL;
    }

    ~sMD3Mesh()
    {
        SAFE_FREE(pVerts);
        // SAFE_FREE(pNormals);
    }

    void UpdateVertices(int currFrame,int nextFrame,float dt);
    void Render();

};



#endif // _TWISTER_MD3_MESH_H_