#ifndef _TWISTER_COMPOUND_MESH_H_
#define _TWISTER_COMPOUND_MESH_H_

/********************************************************
*   compoundmesh.h                                      *
*   declaration file for the compound mesh class        *
********************************************************/
#include "mesh.h"   // base class lies here
#include <d3dx9.h>
/********************************************************
* struct sCompoundMesh declaration                      *
********************************************************/
struct sCompoundMesh: public iRenderable
{
private :

    // the d3dx mesh
    LPD3DXMESH          m_pD3DXMesh;

public :

    // constructor
    sCompoundMesh();

    // destructor
    ~sCompoundMesh();

    // create a ball
    void CreateSphere(float radius);

    // create as a box
    void CreateBox(float sizeX,float sizeY,float sizeZ);

    // create from a file
    void CreateFromFile(const char* fileName);

    // the rendering function
    void Render();

};
/*--------end of struct sCompoundMesh declaration------*/
#endif // _TWISTER_COMPOUND_MESH_H_