#ifndef _TWISTER_SHADER_H_
#define _TWISTER_SHADER_H_
/****************************************************
*	shader.h									    *
*	header file for the  shader class			    *
*	which eases loading/mannipulating a vertex or   *
*   pixel shader, it is also a base class for both  *
****************************************************/
#include "../hybrid/meshcompiler.h"

/****************************************************
*	class cShader Declaration					    *
****************************************************/
class cShader
{
protected :

    sShaderInterface* m_pInternalShader;
    cShader()
    {        m_pInternalShader=0;    }
    virtual ~cShader()
    {        SAFE_DELETE(m_pInternalShader)    }

public:

	// setting a 4x4 matrix 
	void SetMatrix(const char* constantName,const float* pData)
    {    m_pInternalShader->SetMatrix(constantName,pData);  }

    // setting a triplet vector
    void SetVector(const char* constantName,const float* pData)
    { m_pInternalShader->SetVector(constantName,pData);     }

    // setting an integer
    void SetInteger(const char* constantName,int value)
    { m_pInternalShader->SetInteger(constantName,value);     }

    // setting an float
    void SetFloat(const char* constantName,float value)
    { m_pInternalShader->SetFloat(constantName,value);     }
    
    // activate the shader
    void Activate()
    {   m_pInternalShader->Activate();      }

    // deactivate the shader
    void Deactivate()
    {   m_pInternalShader->DeActivate();    }

};
/*--------end of class cShader declaration---------*/
#endif // _TWISTER_SHADER_H_