#ifndef _TWISTER_TEXT_H_
#define _TWISTER_TEXT_H_

/********************************************************
*	text.h												*
*	header file for text output functions, also			*
*	reading keyboard keys is here						*
********************************************************/
#include <string>
using std::string;

/********************************************************
*	text related functions								*
********************************************************/

//	 initializes the text subsystem
void TextInitialize();

// shuts down the text subsystem
void TextShutDown();

// a printf like function
void TextPrintf(int x,int y,char* text,...);

// gets the key just hit
char TextHitKey();

// get the ASCII code of a key just pressed, using delaying techniques (timeout)
char TextGetKey();

// gets a string for display that represents a certain ASCII code
string TextGetKeyName(unsigned long KeyCode);

/*--------------end of text related functions----------*/
#endif // _TWISTER_TEXT_H_
