#ifndef _TWISTER_INPUT_H
#define _TWISTER_INPUT_H

/****************************************************************
*	input.h														*
*	this is the main header for using direct input				*
*	everything is contained in a single class _INPUT			*
****************************************************************/

#include	"../util/util.h"			//	for singletton class
#define		DIRECTINPUT_VERSION 0x0800
#include	<dinput.h>				//	DirectInput Main Include

/****************************************************************
*	Class cInputSubSystem	definition							*
*	this class represents all the related stuff to direct		*
*	input from the keyboard and from the mouse					*
****************************************************************/

class cInputSubSystem	:	public singleton<cInputSubSystem>
{
private:
	//	this will Initialize direct input
	void InitDI();
	//	use this to clean up direct input
	void EndDI();
	//	use this to start using direct keyoard input
	void InitDKey();
	//	use this to finish using the direct keyboard
	void EndDKey();
	//	this will let you start using drect mouse
	void InitDMouse();
	// to finish using the mouse
	void EndDMouse();


public:

	//	this will hold mouse state and position, global for external use
	DIMOUSESTATE		m_MouseState;
	//	default constructor set nulls
	cInputSubSystem();
	//	destructor will release all direct input stuff
	~cInputSubSystem();
	/// a function that Initializes all direct input stuff
	void Init();

	//	this will return the desired key state
	//	u must use readkeyboard before it
	BOOL KeyDown(UCHAR key);

	//	this will catch all input keyboard and mouse
	//	i may try to make a thread which continuously catches input
	void catchAll();

	//void detectDevices();
};

//	Global Access to DirectInput From Here..
inline cInputSubSystem	*&		Input()		{return cInputSubSystem::GetSingletonPtr();}
/*-------------------------------------------------------------*/
//				End of _TWISTER_INPUT definition

#endif// _TWISTER_INPUT_H


