#pragma once

#include <map>
#include <vector>
#include <string>
using namespace std;

typedef unsigned __int64 uint64;
typedef unsigned __int32 uint32;
typedef map<string, int> namemap;
typedef vector<uint64> cyclevec;


//CProfiler:
//objects of this class can be used in profiling on most late intel processors
//to profile a function call CProfiler::Befor(string id) at it's start
//and CProfiler::After(string id) at its end, where id is a string of your choice
//identifying that function.
//
//Author: Ahmed El Deeb
//Date: 5.12.2005
class CSystemProfiler
{
	string m_Filename;
	namemap names;
	cyclevec avarage;
	cyclevec peak;
	cyclevec before;
	cyclevec after;
	vector<int> occurrences;

	uint64 getCycleCount();
	
	uint64 GetAvarage(int id);
	uint64 GetPeak(int id);

public:

	CSystemProfiler(void);
	~CSystemProfiler(void);

	void SetFilename(string filename);

	void Before(string id);
	void After(string id);
	uint64 GetAvarage(string id);
	uint64 GetPeak(string id);

	void Report();
};
