/********************************************************
* window.h												*
* window class declaration								*
*	part of the Twister 3d engine						*
********************************************************/
#ifndef	_WINDOW_H
#define _WINDOW_H
//	if this is win32..(microsoft windows)
#ifdef		WIN32
//	Say NO to MFC 
#define WIN32_LEAN_AND_MEAN
//	Windows API Includes
#include <windows.h>
#include <windowsx.h>
/********************************************************
*	class cWindow										*
*	encapsulates a win32 window							*
********************************************************/
class cWindow 
{
private:

	HWND		WindowHandle		;		//	this is a handle to the main window object
	LPSTR		ClassName			;		//	name of class to be registered in the registry
	WNDPROC		MessageHandler		;		//	a message handler (pointer to function)


	// fill a window class and register it with a certain message handler function
	void	RegisterClass();

public:

	//		a default window constructor, if no message handler is sent, the default would be used
	cWindow(WNDPROC WinProc=NULL);

	// upon destruction.. unregister the class and Destroy the window
	~cWindow()
	{	Destroy();	}

	//	This will Create a window and shows it
	//	i must send the Width and Height of the client rect required
	//	and the window style and label get default value if
	//	nothing was sent
	void Create(int Width,int Height,
				DWORD WinStyle,
				LPSTR label);

	//	destrot the window if it is required to reCreate it once again
	void Destroy()
	{	DestroyWindow(WindowHandle);	}

	//this will set the window label
	void SetLabel(LPSTR label)
	{SetWindowText(WindowHandle,label);}

	//	gets the handle to the window
	HWND GetHwnd()
	{	return WindowHandle;	}
};
/*------------end of class cWindow----------------------*/

#else	//	something else than WIN32
/*

  //	another implementation could be here (for maybe ?)

*/
#endif	//	WIN32
#endif	//	_WINDOW_H