/********************************************************
*	file.h												*
*	part of the Twister class library					*
*	this is the declaration file for a very simple		*
*	file class											*
********************************************************/

#ifndef _FILE_H_
#define _FILE_H_

#include <stdarg.h>		//	for variable arguments
#include "string.h"

/********************************************************
*	class cFile											*
*	encapsulates a file									*
*	text or binary, and enables reading or writing		*
********************************************************/
class cFile
{
private:

	FILE*	pFile;	//	the file pointer

public:
	cFile()
	{	pFile	=	NULL;	}

	virtual ~cFile()
	{	Close();	}
	

	//	open the file as text or as binary file
	bool Open	(char* Filename,char * format);

	//	write some data into the file
	void Print(const char * Str,...);
	void Println(const char * Str,...);
	void Write(void* pData,int Size)		{	fwrite(pData,Size,1,pFile);	}
	void Read (void* pData,int Size)		{	fread (pData,Size,1,pFile);	}

	//	Split a line
	void SplitLine()
	{	String::ReadTokenLine(pFile);	}

	//	close the file and make the pointer null
	void Close()
	{	if(pFile)		fclose(pFile);			pFile=NULL;	}

	//	checks if the file is true
	bool IsOpen()
	{		return pFile!=NULL;		}
};
/*------------------end of class cFile-----------------*/

#endif // _FILE_H_