#ifndef _FRAMECONTROL_H_
#define _FRAMECONTROL_H_

/********************************************************
*	FrameControl.h										*
*	By Shady El Mously									*
*	part of the Twister 3d engine						*
*	this is the header for the frame control class		*
********************************************************/
#include <windows.h>


#define NUM_FRAMES_AVERAGED	50
/********************************************************
*	class cFrameController								*
*	Represents a timer object which is used to lock the	*
*	FrameRate of a Rendering loop						*
*	it also keeps track and calculates the number of	*
*	frames per second									*
********************************************************/
class cFrameController
{
private:
	
	int				FrameRate;

	LONGLONG		performanceFrequency				;	//	performance frquency of current machine
	LONGLONG		currentTime							;	//	Current time
	DWORD			timeCount							;	//	tim count for each frame
	LONGLONG		nextTime							;	//	time for next frame

	int				frameTime							;	//	time for a frame 
	int				FrameRateArrays[NUM_FRAMES_AVERAGED]	;	// array to average


public :
	
	//	constructor and destructor
	cFrameController();
	virtual ~cFrameController(){}

	//	the delta time
	unsigned long	deltaTime	;

	// this is a called once function which will set the timer necessary for synchronization
	// the frame rate required is given here... by default it is 30
	void setFps(int fps=30);
	
	//	this function will return true if the time to Render a frame has occured
	bool isReady();
	//	adjusts the time settings of the frame contm_Roller
	//	and calculate the average frame rate
	void update();

};
/*----------end of cFrameController declaration--------*/

#endif //_FRAMECONTROL_H_