#include "singleton.h"
#include "point2di.h"

#ifndef _TWISTER_MOUSE_H_
#define _TWISTER_MOUSE_H_

/********************************************************************
*	struct sMouse													*
*	a singleton class represeting the simple object					*
*	holding information about the mouse	used						*
*	which is the position and the buttons state						*
********************************************************************/
struct sMouse: public singleton<sMouse>
{
	//	this is the only one
	point2di	m_Loc;
	bool		m_bLButtonDown	;		//	left	button is	down
	bool		m_bRButtonDown	;		//	right	button is	down
	bool		m_bMButtonDown	;		//	middle	button is	down
	long		m_DeltaX		;		//	deltax of the mouse from last frame ,changes every frame
	long		m_DeltaY		;		//	deltay of the mouse from last frame ,changes every frame
	long		m_DeltaZ		;		//	deltaz of the mouse from last frame ,changes every frame
	float		m_Xpos			;		//	3d xposition
	float		m_Ypos			;		//	3d yposition
	float		m_Zpos			;		//	3d zposition


	//	constructor just Zeros out everything
	sMouse()
	{
		//memset(this,0,sizeof(*this));
	}
};

//	access all mouse data from this fucntion.
inline sMouse	*& Mouse(){return sMouse::GetSingletonPtr();}
/*---------------------end of class mouseinfo----------------------*/
#endif // _TWISTER_MOUSE_H_