#ifndef _RESOURCE_ENTRY_H_
#define _RESOURCE_ENTRY_H_

/************************************************
*	resourceentry.h								*
*	by Shady El Mously							*
*	part of Twister 3d engine					*
*	this is the header declaration file for		*
*	the resourceentrty structure				*
************************************************/

/********************************************************
*	struct sResourceEntry								*
*	this is an abstarct base struct						*
*	it should be used as a base for any entry used	in	*
*	a manager mainly..each entry should have some sort	*
*	of pointer to any data..a texture.. a mesh..a sound	*
*	..etc the function (FreeResource) must be			*
*	responsible of	deallocating this data				*
********************************************************/
struct sResourceEntry
{
	int				m_ID;				//	unique id for each texture entry, the manager should Assign this id
	int				RefCount;			//	if it is Zero, the resource should be Destroyed
	
	//	pure virtual function, called when the resource is free (deallocatuing its memory)
	virtual void FreeResource()=0;
};
/*--------end of sResourceEntry declaration------------*/



#endif // _RESOURCE_ENTRY_H_