/********************************************************
*	singleton.h											*
*	by shady el mously									*
*	header file for the template singleton class		*
********************************************************/
#ifndef _SINGLETON_H_
#define _SINGLETON_H_
#include <assert.h>
/********************************************************
* generic singletton class								*
*	used to Create manager classes , enables the		*
*	existence of just one object per class				*
********************************************************/
template <typename T> class singleton
{
	static T* ms_Singleton;

public:

	singleton(void)
	{
		assert(!ms_Singleton);
		__int64 offset=(__int64)(T*)1-(__int64)(singleton<T>*)(T*)1;
		ms_Singleton=(T*)((__int64)this+offset);
	}

	virtual ~singleton(void)
	{assert(ms_Singleton);ms_Singleton=0;}

	static T& GetSingleton(void)
	{assert(ms_Singleton);return (*ms_Singleton);}
	
	static T*& GetSingletonPtr(void)
	{return ms_Singleton;}

};

//	and this is the static pointer to object
template <typename T> T* singleton<T>::ms_Singleton=0;
/*---------------end of class singleton----------------*/
#endif // _SINGLETON_H_